#pragma once

#include "Types.h"

namespace MicrocodeAssembler {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;


	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	public:
		MainForm(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  label1;
	protected: 


	protected: 


	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(62, 35);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(146, 13);
			this->label1->TabIndex = 0;
			this->label1->Text = L"BMOW Microcode Assembler";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(274, 87);
			this->Controls->Add(this->label1);
			this->Name = L"Form1";
			this->Text = L"Microcode Assembler";
			this->Activated += gcnew System::EventHandler(this, &MainForm::MainForm_Load);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: 
		void MainForm_Load( System::Object^  sender, System::EventArgs^  e );
		void InitData( array<MicrocodeLine>^ romData );
		void ParseMicrocode( String^ filename );
		void SetAllInstructionsToHalt(array<MicrocodeLine>^ romData);
		unsigned int ParseLine( String^ line, unsigned int nextAddress, array<MicrocodeLine>^ romData );
		unsigned int GetCondtionBit(String^ condition);
		bool ParseLineCommands(int lineNum, unsigned int nextAddress, int cc, int numLines, String^ line, array<MicrocodeLine>^ romData);
		bool CheckMutuallyExclusiveCommands(int lineNum, array<String^>^ commands, String^ command1, String^ command2);
		bool CheckConflictingAddressSources(int lineNum, unsigned int nextAddress, int cc, array<MicrocodeLine>^ romData, unsigned int sourceAddressType);
		bool ParseDestination(int lineNum, unsigned int nextAddress, int cc, String^ destStr, array<MicrocodeLine>^ romData);
		bool ParseAddSubtractSources(int lineNum, unsigned int nextAddress, int cc, String^ sourcesStr, String^ opString, unsigned int aluOpIncDec, unsigned int aluOpNormal, unsigned int aluOpThreeOperand, array<MicrocodeLine>^ romData);
		bool ParseLeftOperand(unsigned int nextAddress, int cc, String^ leftOp, array<MicrocodeLine>^ romData);
		bool ParseRightOperand(int lineNum, unsigned int nextAddress, int cc, String^ rightOp, array<MicrocodeLine>^ romData);
		void SaveData( String^ filename, array<MicrocodeLine>^ romData );
		void ClearBit(unsigned int% data, int bit);
		void SetBit(unsigned int% data, int bit);
		int GetBit(unsigned int% data, int bit);
		void SetField(unsigned int% data, unsigned int mask, int bit, unsigned int value);
		unsigned int GetField(unsigned int data, unsigned int mask, int bit);
		bool ShouldUseX7(unsigned int nextAddress, int cc, array<MicrocodeLine>^ romData);

		static bool s_bFirstLoad = true;

		static String^ kOpcodeStr = L"opcode:";

		static String^ kIncSPStr = L"sp++";
		static String^ kDecSPStr = L"sp--";
		static String^ kIncPCStr = L"pc++";
		static String^ kIncARStr = L"ar++";
		static String^ kLoadOpStr = L"nextop";
		static String^ kLatchAllCCStr = L"latchallcc";
		static String^ kLatchNZStr = L"latchnz";
		static String^ kLatchNZCStr = L"latchnzc";
		static String^ kShiftCCStr = L"shiftcc";
		static String^ kEnableInterruptStr = "enableInt";
		static String^ kDisableInterruptStr = "disableInt";
		static String^ kAssignStr = L"<-";

		static String^ kRegA = "A";
		static String^ kRegX = "X";
		static String^ kRegY = "Y";
		static String^ kRegX7 = "X7";
		static String^ kReg0 = "0";
		static String^ kRegT = "T";
		static String^ kRegPCLO = "pclo";
		static String^ kRegPCHI = "pchi";
		static String^ kRegPCBANK = "pcbank";
		static String^ kRegARLO = "arlo";
		static String^ kRegARHI = "arhi";
		static String^ kRegARBANK = "arbank";
		static String^ kRegSPLO = "splo";
		static String^ kRegSPHI = "sphi";
		static String^ kRegSPBANK = "spbank";
		static String^ kRegMEMPC = "mem(pc)";
		static String^ kRegMEMAR = "mem(ar)";
		static String^ kRegMEMSP = "mem(sp)";

		static String^ kALUStr = "alu(";
		static String^ kParenStr = ")";
		static String^ kPlusStr = "+";
		static String^ kMinusStr = "-";
		static String^ kOneStr = "1";
	};
}

