#pragma once

const int kROMSize = 131072;

const int kLowDestBit = 0;
const int kLoadOpBit = 3;
const int kSPDirIEDataBit = 4;
const int kCountSPBit = 5;
const int kIncPCBit = 6;
const int kIncARBit = 7;

const int kShifterS0Bit = 9;
const int kShifterS1Bit = 8;

const int kDriveALUBit = 16;

const int kAddressSelBit = 1;
const unsigned int kAddressSelMask = 0xFFFFFFF9;
const unsigned int kAddressSelSP = 1;
const unsigned int kAddressSelAR = 2;
const unsigned int kAddressSelPC = 3;

const int kLoadDestBit = 17;
const unsigned int kLoadDestMask = 0xFFF1FFFF;

const unsigned int kLoadDestSPHI = 0;
const unsigned int kLoadDestSPBANK = 1;
const unsigned int kLoadDestARLO = 2;
const unsigned int kLoadDestARHI = 3;
const unsigned int kLoadDestARBANK = 4;
const unsigned int kLoadDestPCLO = 5;
const unsigned int kLoadDestPCHI = 6;
const unsigned int kLoadDestPCBANK = 7;

const unsigned int kLoadDestMem = 0;
const unsigned int kLoadDestSPLO = 1;
const unsigned int kLoadDestT = 2;
const unsigned int kLoadDestY = 3;
const unsigned int kLoadDestX = 4;
const unsigned int kLoadDestA = 5;

const int kLeftOpBit = 22;
const unsigned int kLeftOpMask = 0xFF3FFFFF;
const int kLeftOp0 = 0;
const int kLeftOpX = 1;
const int kLeftOpX7 = 2;
const int kLeftOpY = 2;
const int kLeftOpA = 3;

const int kRightOpBit = 20;
const unsigned int kRightOpMask = 0xFFCFFFFF;
const int kRightOpADRBANK = 0;
const int kRightOpADRHI = 1;
const int kRightOpADRLO = 2;
const int kRightOpT = 3;

// aluop(4) | alumode | alucarry
const int kALUFuncBit = 10;
const unsigned int kALUFuncMask = 0xFFFF03FF;
const int kALUFuncZero = 0x0F;
const int kALUFuncOne = 0x33;
const int kALUFuncA = 0x3F;
const int kALUFuncB = 0x2B;
const int kALUFuncAminus1 = 0x3D;
const int kALUFuncAplus1 = 0x00;
const int kALUFuncAplusB = 0x25;
const int kALUFuncAminusB = 0x18;
const int kALUFuncAplusBplus1 = 0x24;
const int kALUFuncAminusBminus1 = 0x19;
const int kALUFuncAplusA = 0x31;
const int kALUFuncAplusAplus1 = 0x30;

public value class MicrocodeLine
{
public:
	bool wasSet;
	unsigned int data;
};
